{{
File  :  RGB_LED_Matrix_Demo.spin
Author:  John Zhong
Company: SimplyTronics
Version: 1.0
Date   : 2012-11-09     

}}

con             
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

_pinTx                    =   0
_pinRx                    =   1    
                  
OBJ
                                    
  RGB    : "RGB_LED_Matrix_Driver_Simple3.spin"

  
pub main | index ,temp,temp2

{/*******************************************************
              Start and init the serial port
              Clear the screen
*******************************************************/}
    RGB.Start(_pinRx,_pinTx, 19200)   
    waitcnt(clkfreq*2 + cnt)                                          ' Please insert a pause to wait for the RGB Module start            
  

    'RGB.ChangeBaudrate(115200)  'max ??172800      
    'waitcnt(clkfreq + cnt)  
                                            
 repeat
 
    RGB.ClearScreen($0000_0000)
    RGB.UpdateScreen
    
{/*******************************************************
              Display 'S', 'T'
*******************************************************/}  
    RGB.SetMode(RGB#_ModeGray)
    RGB.ASCII_0508NBG("S",0, 0,$FF_00_FF  )
    RGB.SetMode(RGB#_ModeOverlay)
    RGB.ASCII_0508NBG("T",3, 3,$00_FF_FF  )
    RGB.UpdateScreen 
    waitcnt(clkfreq + cnt)

    RGB.SetMode(RGB#_ModeNormal)   

{/*******************************************************
              Display "Rainbow" Pattern 1
*******************************************************/}  
    temp := 0        
    repeat  index from 15 to 0
       RGB.Line(index,15, 15, index, long[@sixteenColors][temp])
       temp++
       waitcnt(clkfreq /100 + cnt)
    RGB.UpdateScreen 
    waitcnt(clkfreq + cnt)
    
{/*******************************************************
              Display "Rainbow" Pattern 2
*******************************************************/}                                                         
    repeat  index from 0 to 15
       RGB.Line(0, index, index, 0, long[@sixteenColors][index])
       waitcnt(clkfreq /100 + cnt)
    RGB.UpdateScreen
                  
    RGB.SetMode(RGB#_ModeNormal)
    RGB.ClearScreen($0000_0000)    
    waitcnt(clkfreq + cnt)
                             
{/*******************************************************
              Display "Rainbow" Pattern 3
*******************************************************/}                                                
    repeat  index from 0 to 15
       RGB.Line(0, index,15,index, long[@sixteenColors][index])
       waitcnt(clkfreq /100 + cnt)
    RGB.UpdateScreen   


{/*******************************************************
              Display "SimplyTronics" String 0816
*******************************************************/}   
       repeat  index from 0 to -88
             
          String_0816NBG(string("SimplyTronics"), index, 0, $00FF0000)
          RGB.updateScreen                         
          waitcnt(clkfreq/20 + cnt)                     
          RGB.ClearScreen($0000_0000)                                                                                                               

 '////////////////////////////////////////////////////////////////
 '               Draw line and circle          
 '////////////////////////////////////////////////////////////////  

      RGB.CopyGDRAM2(0)
      
      RGB.Line(0,0,15,15,$FF_FF_FF  )
            
      repeat index from 2 to 7   
          RGB.Circle(7,7,index, long[@sixteenColors][index])
          RGB.UpdateScreen          
          waitcnt(clkfreq/5 + cnt)
          RGB.DisplayGDRAM(0)
          RGB.UpdateScreen
                      
          
 '///////////////////////////////////////////////////////////////
 '                       Display Customer BMP
 '///////////////////////////////////////////////////////////////
      RGB.ClearScreen($00) 
      RGB.DisplayCustomerBMP1(0,0)
      RGB.UpdateScreen         
      waitcnt(clkfreq*2 + cnt)    
     
 '///////////////////////////////////////////////////////////////
 '                       Color Inverse
 '///////////////////////////////////////////////////////////////
      RGB.DisplayCustomerBMP1(0,0)     
      RGB.CopyGDRAM2(0)  
      RGB.ScreenInverse(0)
      RGB.UpdateScreen       
      waitcnt(clkfreq*2 + cnt)

      
      RGB.CopyGDRAM2(0)      
      RGB.ScreenInverse(0)
      RGB.UpdateScreen   
      waitcnt(clkfreq*2 + cnt)
                     
       RGB.CopyGDRAM2(1)
                     
                  
'////////////////////////////////////////////////////////////////
 '           Display Characters without Background color             
 '////////////////////////////////////////////////////////////////
       RGB.CopyGDRAM2(0) 
       repeat  index from 32 to 64                                  
             RGB.ASCII_0508NBG(index,index//8,index//8,$FF_FF_FF  )
             RGB.UpdateScreen                    
             waitcnt(clkfreq/10 + cnt)
             RGB.ClearASCII_NBG
                                                        
                                 
       repeat  index from 32 to 64
            RGB.ASCII_0816NBG(index,index//8,index//8,$FF_FF_FF  )
            RGB.UpdateScreen                         
            waitcnt(clkfreq/10 + cnt)        
            RGB.ClearASCII_NBG    
                                                                                 
                    
''////////////////////////////////////////////////////////////////
 '               Display Characters with Background color                 
 '////////////////////////////////////////////////////////////////
     
       repeat  index from 32 to 64                                    
                     
             RGB.ASCII_0508(index,0+(index//8),index//8,?Temp,$0F_00_00  )
             RGB.UpdateScreen    
             waitcnt(clkfreq/10 + cnt)
             RGB.ClearScreen($00)
                                       
       repeat  index from 32 to 64                       
             RGB.ASCII_0816(index,0+(index//8),0,?Temp,$0F_00_00  )
             RGB.UpdateScreen               
             waitcnt(clkfreq/10 + cnt)
             RGB.ClearScreen($00)
                                       
             
       RGB.DisplayGDRAM(1)
       RGB.UpdateScreen
                              
   
 '////////////////////////////////////////////////////////////////
 '                Display   Color blocks                
 '////////////////////////////////////////////////////////////////                                                 
  
      repeat index from 0 to 15  
          RGB.SetWindows(index,index,index+7,index+7)
          RGB.TxDataLength(192)
          Temp:=?Temp2
          repeat 64
           RGB.TxByte(Temp*index)
           RGB.TxByte(Temp2<<index)
           RGB.TxByte(Temp<<index)
           
          RGB.UpdateScreen
        
          waitcnt(clkfreq/20 + cnt)                       
          RGB.DisplayGDRAM(0)
          

 '////////////////////////////////////////////////////////////////
 '               Display Parallax Logo without BackGround  Color 
 '////////////////////////////////////////////////////////////////

    waitcnt(clkfreq/2 + cnt)      
        
     RGB.SetColors($FF_00_FF  ,$00_00_00  )
     RGB.CopyGDRAM2(0)           
    repeat index from 0 to -72              
         RGB.ClearASCII_NBG                                      
         RGB.DisplayPropellerLogoNBG(index,0)
         RGB.UpdateScreen           
         waitcnt(clkfreq/10 + cnt)
               
      
 '////////////////////////////////////////////////////////////////
 '               Display Parallax Logo with Background  Color            
 '////////////////////////////////////////////////////////////////        
    RGB.ClearScreen($00)
    RGB.SetColors($FF_FF_FF  ,$5A_00_00  )
    'RGB.CopyGDRAM2(0)                  
    repeat index from 0 to -72
        RGB.ClearASCII_NBG      
        RGB.DisplayParallaxLogo(index,0)
        'RGB.UpdateScreen 
        waitcnt(clkfreq/10 + cnt) 
        RGB.ClearScreen($00)         

{/*******************************************************
         Function: display the 0816 ASCII string
*******************************************************/}      
pub String_0816NBG(stringPtr,StartX,StartY,ForegroundColor) | index    

     index := 0
     RGB.TxDatPackHead(RGB#_SetForegroundColor, ForegroundColor)
     RGB.TxDatPackHead(RGB#_SetPointerY, StartY)
      
     repeat strsize(stringPtr)
          RGB.TxDatPackHead(RGB#_SetPointerX, StartX + (index * 8))       
          RGB.TxDatPackHead(RGB#_DisplayChar0816NBG, byte[stringPtr + index])
          index++      


dat

sixteenColors
    long $000000FF 
    long $006500FF 
    long $00E000FF
    long $00D600FF
          
    long $00E600FF    
    long $00FF00D7 
    long $00FF0010 
    long $00FF3C00
          
    long $00FFB500    
    long $00F7FF00 
    long $009EFF00 
    long $0000FF11
          
    long $0000FF76     
    long $0000FFE2 
    long $0000FDFF 
    long $00005DFF
 